############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import socket
from threading import Thread
from ZSI.ServiceContainer import ServiceContainer
#from ZSI.ServiceContainer import WSResourceService
#from pyGridWare.generated.stubs.WS_BaseNotification_services import Notify
#from pyGridWare.generated.types.NotificationConsumer_services_types import *
from pyGridWare.notification.NotificationConsumerContext import NotificationConsumerContext
from pyGridWare.generated.notification.NotificationConsumerService import NotificationConsumerService

class NotificationConsumer(Thread):
    def __init__(self, path='/wsrf/services/NotificationConsumerService', server_address=('', 50001)):
        self._sc = ServiceContainer(server_address)
        self._service = NotificationConsumerService(path)
        self._ctx = NotificationConsumerContext()
        path = self._service.getPost()
        port = self._sc.server_port
        host = self._sc.server_address[0]
        if not host: host = socket.gethostbyaddr(socket.gethostname())[0]
        self._service.setServiceURL("http://%s:%d%s" %(host,port,path))
        url = self._service.getServiceURL()
        print "*" *90
        print "URL: ", url 
        print "*" *90
        #self._ctx.setAddress(address="http://bundy.localdomain:50001%s" %path)
        self._ctx.setAddress(address=url)
        self._sc.setNode(self._service, path)
        Thread.__init__(self)

    def getNotificationContext(self):
        return self._ctx

    def run(self):
        self._sc.serve_forever()

