import time
from threading import _Timer

class Timer(_Timer):
    """Call a function at a specified interal(seconds):

    t = Timer(30.0, f, args=[], kwargs={})
    t.start()
    t.cancel() # stop the timer's action if it's still waiting
    """
    def setDelay(self, delay):
        self.interval = delay

    def getDelay(self, delay):
        self.interval = delay

    def run(self):
        while not self.finished.isSet():
            self.finished.wait(self.interval)
            if self.finished.isSet(): break
            self.function(*self.args, **self.kwargs)


class ResourceSweeper:
    def __init__(self, resourceHome, delay):
        self.resourceHome = resourceHome
        self.timer = Timer(delay, self.sweep)
        self.timer.start()

    def sweep(self):
        print "SWEEP"
        currentTime = time.time() + time.timezone
        for resource in self.resourceHome.getResources():
            terminationTime = resource.getTerminationTime()
            if terminationTime is not None and terminationTime < currentTime:
                key = resource.getResourceID()
                print "Sweep terminate %s" %key
                self.resourceHome.setTerminationTime(key, None)

    def setSweeperDelay(self, delay):
        self.timer.setDelay(delay)

    def getSweeperDelay(self):
        self.timer.getDelay()
