from ZSI.ServiceContainer import WSResourceService
from pyGridWare.security.gss.GssSignatureHandler import GssSignatureHandler


class GssSecureResourceService(WSResourceService):
    def __init__(self, post):
        WSResourceService.__init__(self, post)
        self._contextID = None

    def verify(self, ps):
        signature = GssSignatureHandler()
        signature.verify(ps)
        self._contextID = signature.getContextID()

    def sign(self, sw):
        signature = GssSignatureHandler()
        signature.setContextID(self._contextID)
        signature.sign(sw)
